# maxtest.R
##  author: John C. Nash -- revised 2023-10-21
# rm(list=ls())
cat("maxfn.R -- test that maximize=TRUE works correctly\n")

## Notes Dec 2 2021
##?? When we are using grfwd, the sign of the gradient is wrong. Why??

require(optimx)
# source("optimx/tests/maxfn.R")
source("maxfn.R")
sessionInfo()

n<-4
xx<-rep(1,n) # start at all 1s
rv0 <- Rvmmin(xx, maxfn, maxfn.g, control=list(maximize=TRUE, trace=2))
rv0
rv0f <- Rvmmin(xx, maxfn, "grfwd", control=list(maximize=TRUE, trace=2))
rv0f
nrv0 <- Rvmmin(xx, negmaxfn, negmaxfn.g, control=list(trace=4))
nrv0
nrv0f <- Rvmmin(xx, negmaxfn, "grfwd", control=list(trace=4))
nrv0f


# Conflicting controls -- 'maximize' takes precedence over 'fnscale'
ansconf0<-optimr(xx,maxfn, gr=maxfn.g, method="Rvmmin", control=list(maximize=TRUE, trace=2))
proptimr(ansconf0) # should work OK

ansconf0f<-optimr(xx,maxfn, gr="grfwd", method="Rvmmin", control=list(maximize=TRUE, trace=4))
proptimr(ansconf0f) # should work OK
ansconf0c<-optimr(xx,maxfn, gr="grcentral", method="Rvmmin", control=list(maximize=TRUE, trace=2))
proptimr(ansconf0c) # should work OK
ansconf0n<-optimr(xx,maxfn, gr="grnd", method="Rvmmin", control=list(maximize=TRUE, trace=2))
proptimr(ansconf0n) # should work OK
ansconf1<-optimr(xx,maxfn, gr="grfwd", method="Rvmmin", control=list(maximize=TRUE, fnscale=1))
proptimr(ansconf1) # should work OK
# Warning
ansconf2<-optimr(xx,maxfn, gr="grfwd", method="Rvmmin", control=list(maximize=FALSE, fnscale=-1))
proptimr(ansconf2) # should work OK


